searchNodes=[{"ref":"ExCwmanage.html","title":"ExCwmanage","type":"module","doc":"ExCwmanage Required Configuration The following configuration information is required to connect to the ConnectWise API. This can be supplied through creating a dev.secret.exs and prod.secret.exs file or by setting environment variables (preferred for production). Obtaining required configuration API root: This will be one of the following site urls with additional version information to create the api url. This is subject to change. api-au.myconnectwise.net api-eu.myconnectwise.net api-na.myconnectwise.net Example API root url https://api-na.myconnectwise.net/v2019_5/apis/3.0/. As of 2019 the &quot;release&quot; tracks your connectwise version. Please see the following documentation https://developer.connectwise.com/Best_Practices/Manage_Cloud_URL_Formatting?mt-learningpath=manage Company Id: When you log into connectwise this is your Company Name Public and Private Key: (Follow this guide https://docs.connectwise.com/ConnectWise_Documentation/090/040/010/010/060) Create a &quot;client id&quot;: https://developer.connectwise.com/ClientID Using secret files dev.secret.exs and prod.secret.exs are in the config folder and are called based on the environment you are in. Below is an example file use Mix.Config config :ex_cwmanage, cw_api_root: &quot;https://api-na.myconnectwise.net/v4_6_release/apis/3.0/&quot;, cw_companyid: &quot;MYCOMPANYID&quot;, cw_publickey: &quot;MYPUBLICKEY&quot;, cw_privatekey: &quot;MYPRIVATEKEY&quot; cw_clientid: &quot;MYCLIENTID&quot; Using environment variables The following environment variables need to be set if you are not using a secret file. This is the recommended method for production. CW_API_ROOT CW_COMPANYID CW_PUBLICKEY CW_PRIVATEKEY CW_CLIENTID Usage API Requests The api follows the standard HTTP REST conventions outlined in the ConnectWise API HTTP Methods POST Create entity or any non CRUD action GET Return entity or list of entities PUT Replace all fields on entity with supplied fields PATCH Update specific fields on an entity DELETE Remove entity Options Different resources in the api allow addition options to be passed along using normal url &quot;query&quot; formatting. Full details are available here https://developer.connectwise.com/Products/Manage/Developer_Guide#Query_String_Parameters Examples ExCwmanage.Api.get(&quot;/system/info&quot;) ExCwmanage.Api.get(&quot;/finances/invoices/count&quot;, [conditions: &quot;id=1234&quot;]) ExCwmanage.Api.get(&quot;/finances/invoices&quot;, [conditions: &quot;id=1234&quot;, orderBy: &quot;id&quot;]) ExCwmanage.Api.get_page(&quot;/finances/invoices&quot;, [pagesize: 100, pageid: 123]) The ConnecWise API https://developer.connectwise.com/Products/Manage/Developer_Guide Changes version 0.3.0 - removed version tag in accept header that bumps us up to the latest version of the API. The api should be backwards compatible but this is considered a breaking change. Installation If available in Hex, the package can be installed by adding ex_cwmanage to your list of dependencies in mix.exs: def deps do [ {:ex_cwmanage, &quot;~&gt; 0.3.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/ex_cwmanage."},{"ref":"ExCwmanage.Api.html","title":"ExCwmanage.Api","type":"module","doc":"API for Excwmanage, this forwards requests to the designated API client (normally HTTP)"},{"ref":"ExCwmanage.Api.html#delete/2","title":"ExCwmanage.Api.delete/2","type":"function","doc":"Callback implementation for ExCwmanage.Api.Behaviour.delete/2."},{"ref":"ExCwmanage.Api.html#get/2","title":"ExCwmanage.Api.get/2","type":"function","doc":"Callback implementation for ExCwmanage.Api.Behaviour.get/2."},{"ref":"ExCwmanage.Api.html#get_page/2","title":"ExCwmanage.Api.get_page/2","type":"function","doc":"Callback implementation for ExCwmanage.Api.Behaviour.get_page/2."},{"ref":"ExCwmanage.Api.html#get_raw/2","title":"ExCwmanage.Api.get_raw/2","type":"function","doc":"Callback implementation for ExCwmanage.Api.Behaviour.get_raw/2."},{"ref":"ExCwmanage.Api.html#get_stream/2","title":"ExCwmanage.Api.get_stream/2","type":"function","doc":"Callback implementation for ExCwmanage.Api.Behaviour.get_stream/2."},{"ref":"ExCwmanage.Api.html#patch/2","title":"ExCwmanage.Api.patch/2","type":"function","doc":"Callback implementation for ExCwmanage.Api.Behaviour.patch/2."},{"ref":"ExCwmanage.Api.html#post/2","title":"ExCwmanage.Api.post/2","type":"function","doc":"Callback implementation for ExCwmanage.Api.Behaviour.post/2."},{"ref":"ExCwmanage.Api.html#put/2","title":"ExCwmanage.Api.put/2","type":"function","doc":"Callback implementation for ExCwmanage.Api.Behaviour.put/2."},{"ref":"ExCwmanage.Api.Behaviour.html","title":"ExCwmanage.Api.Behaviour","type":"behaviour","doc":"Raw API commands"},{"ref":"ExCwmanage.Api.Behaviour.html#c:delete/1","title":"ExCwmanage.Api.Behaviour.delete/1","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:delete/2","title":"ExCwmanage.Api.Behaviour.delete/2","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:get/1","title":"ExCwmanage.Api.Behaviour.get/1","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:get/2","title":"ExCwmanage.Api.Behaviour.get/2","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:get_page/1","title":"ExCwmanage.Api.Behaviour.get_page/1","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:get_page/2","title":"ExCwmanage.Api.Behaviour.get_page/2","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:get_raw/1","title":"ExCwmanage.Api.Behaviour.get_raw/1","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:get_raw/2","title":"ExCwmanage.Api.Behaviour.get_raw/2","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:get_stream/1","title":"ExCwmanage.Api.Behaviour.get_stream/1","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:get_stream/2","title":"ExCwmanage.Api.Behaviour.get_stream/2","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:patch/1","title":"ExCwmanage.Api.Behaviour.patch/1","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:patch/2","title":"ExCwmanage.Api.Behaviour.patch/2","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:post/1","title":"ExCwmanage.Api.Behaviour.post/1","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:post/2","title":"ExCwmanage.Api.Behaviour.post/2","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:put/1","title":"ExCwmanage.Api.Behaviour.put/1","type":"callback","doc":""},{"ref":"ExCwmanage.Api.Behaviour.html#c:put/2","title":"ExCwmanage.Api.Behaviour.put/2","type":"callback","doc":""},{"ref":"ExCwmanage.Api.HTTPClient.html","title":"ExCwmanage.Api.HTTPClient","type":"module","doc":"HTTP Interaction with the ConnectWise api. Handles generation of security token and and all http communication"},{"ref":"ExCwmanage.Api.HTTPClient.html#generate_headers/1","title":"ExCwmanage.Api.HTTPClient.generate_headers/1","type":"function","doc":""},{"ref":"ExCwmanage.Api.HTTPClient.html#generate_parameters/1","title":"ExCwmanage.Api.HTTPClient.generate_parameters/1","type":"function","doc":""},{"ref":"ExCwmanage.Api.HTTPClient.html#generate_upload_form/3","title":"ExCwmanage.Api.HTTPClient.generate_upload_form/3","type":"function","doc":""},{"ref":"ExCwmanage.Api.HTTPClient.html#generate_url/3","title":"ExCwmanage.Api.HTTPClient.generate_url/3","type":"function","doc":""},{"ref":"ExCwmanage.Api.HTTPClient.Stream.html","title":"ExCwmanage.Api.HTTPClient.Stream","type":"module","doc":"Provides a streaming interface for connectwise paginated results"},{"ref":"ExCwmanage.Api.HTTPClient.Stream.html#new/1","title":"ExCwmanage.Api.HTTPClient.Stream.new/1","type":"function","doc":"resource = {path, params} path is the url (ie &quot;/service/tickets&quot;) params is a list keyword list of standard options (ie [fields: &quot;id&quot;, conditions: &quot;date &gt; [2019-01-01]&quot;])"},{"ref":"ExCwmanage.Manage.html","title":"ExCwmanage.Manage","type":"module","doc":"Common commands that use the api"},{"ref":"ExCwmanage.Manage.Contacts.html","title":"ExCwmanage.Manage.Contacts","type":"module","doc":"Some shortcuts for Contacts"},{"ref":"ExCwmanage.Manage.Contacts.html#get_contacts_for_company/1","title":"ExCwmanage.Manage.Contacts.get_contacts_for_company/1","type":"function","doc":""},{"ref":"ExCwmanage.Manage.System.html","title":"ExCwmanage.Manage.System","type":"module","doc":"Some shortcuts for System"},{"ref":"ExCwmanage.Manage.System.html#departments/0","title":"ExCwmanage.Manage.System.departments/0","type":"function","doc":""},{"ref":"ExCwmanage.Manage.System.html#info/0","title":"ExCwmanage.Manage.System.info/0","type":"function","doc":""},{"ref":"ExCwmanage.Manage.System.html#others/0","title":"ExCwmanage.Manage.System.others/0","type":"function","doc":""},{"ref":"ExCwmanage.Manage.System.html#services/0","title":"ExCwmanage.Manage.System.services/0","type":"function","doc":""},{"ref":"readme.html","title":"ExCwmanage","type":"extras","doc":"ExCwmanage"},{"ref":"readme.html#required-configuration","title":"ExCwmanage - Required Configuration","type":"extras","doc":"The following configuration information is required to connect to the ConnectWise API. This can be supplied through creating a dev.secret.exs and prod.secret.exs file or by setting environment variables (preferred for production). Obtaining required configuration API root: This will be one of the following site urls with additional version information to create the api url. This is subject to change. api-au.myconnectwise.net api-eu.myconnectwise.net api-na.myconnectwise.net Example API root url https://api-na.myconnectwise.net/v2019_5/apis/3.0/. As of 2019 the &quot;release&quot; tracks your connectwise version. Please see the following documentation https://developer.connectwise.com/Best_Practices/Manage_Cloud_URL_Formatting?mt-learningpath=manage Company Id: When you log into connectwise this is your Company Name Public and Private Key: (Follow this guide https://docs.connectwise.com/ConnectWise_Documentation/090/040/010/010/060) Create a &quot;client id&quot;: https://developer.connectwise.com/ClientID Using secret files dev.secret.exs and prod.secret.exs are in the config folder and are called based on the environment you are in. Below is an example file use Mix.Config config :ex_cwmanage, cw_api_root: &quot;https://api-na.myconnectwise.net/v4_6_release/apis/3.0/&quot;, cw_companyid: &quot;MYCOMPANYID&quot;, cw_publickey: &quot;MYPUBLICKEY&quot;, cw_privatekey: &quot;MYPRIVATEKEY&quot; cw_clientid: &quot;MYCLIENTID&quot; Using environment variables The following environment variables need to be set if you are not using a secret file. This is the recommended method for production. CW_API_ROOT CW_COMPANYID CW_PUBLICKEY CW_PRIVATEKEY CW_CLIENTID"},{"ref":"readme.html#usage","title":"ExCwmanage - Usage","type":"extras","doc":"API Requests The api follows the standard HTTP REST conventions outlined in the ConnectWise API HTTP Methods POST Create entity or any non CRUD action GET Return entity or list of entities PUT Replace all fields on entity with supplied fields PATCH Update specific fields on an entity DELETE Remove entity Options Different resources in the api allow addition options to be passed along using normal url &quot;query&quot; formatting. Full details are available here https://developer.connectwise.com/Products/Manage/Developer_Guide#Query_String_Parameters Examples ExCwmanage.Api.get(&quot;/system/info&quot;) ExCwmanage.Api.get(&quot;/finances/invoices/count&quot;, [conditions: &quot;id=1234&quot;]) ExCwmanage.Api.get(&quot;/finances/invoices&quot;, [conditions: &quot;id=1234&quot;, orderBy: &quot;id&quot;]) ExCwmanage.Api.get_page(&quot;/finances/invoices&quot;, [pagesize: 100, pageid: 123]) The ConnecWise API https://developer.connectwise.com/Products/Manage/Developer_Guide Changes version 0.3.0 - removed version tag in accept header that bumps us up to the latest version of the API. The api should be backwards compatible but this is considered a breaking change."},{"ref":"readme.html#installation","title":"ExCwmanage - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding ex_cwmanage to your list of dependencies in mix.exs: def deps do [ {:ex_cwmanage, &quot;~&gt; 0.3.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/ex_cwmanage."}]